/** 
 *   FIXME ....
 *
 *   (c) Copyright 2004 Federico Bareilles <fede@iar.unlp.edu.ar>,
 *   Instituto Argentino de Radio Astronomia (IAR).
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU General Public License as
 *   published by the Free Software Foundation; either version 2 of
 *   the License, or (at your option) any later version.
 *     
 *   The author does NOT admit liability nor provide warranty for any
 *   of this software. This material is provided "AS-IS" in the hope
 *   that it may be useful for others.
 *
 *   TODO: ???
 **/

#ifndef _PCR_H
#define _PCR_H

#define PCR_COMMAND_LINE_LEGEND 256

/* #define NO_PCR_PROMPT */

#define PCR_MAIN_ID "main"
#define PCR_ID_PROPT '>'



struct pcr_client {
	int fd;
	int transfer;
	int alive;
	char *id;
	char cmd[PCR_COMMAND_LINE_LEGEND];
	int cmd_ind;
	char *mesg;
	struct pcr_client *prev;
	struct pcr_client *next;
};


struct pcr_command {
	char *name;
	int (*func)(struct pcr_client *cl, 
		    struct pcr_client *current);
	/* ... */
};


#define PCR_CM_QUIT       "q"
#define PCR_CM_START      "s"
#define PCR_CM_STOP       "t"
#define PCR_CM_MESSAGE    "m"
#define PCR_CM_WHO        "w"
#define PCR_CM_MESSAGE_TO "to"
#define PCR_CM_WHOAMI     "wa"
#define PCR_CM_SID        "sid"


int pcr_cm_quit(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_start(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_stop(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_message(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_who(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_message_to(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_whoami(struct pcr_client *cl, struct pcr_client *current);
int pcr_cm_set_id(struct pcr_client *cl, struct pcr_client *current);

int process_chat_room_local(struct pcr_command *cm, 
			    int fd_main, char *sock_name );
int process_chat_room_inet(struct pcr_command *cm,
			   int fd_main, int port );

int skip_prompt(char *buff, char **ptrbuff);
int parse_pcr_line(char *line, char **from, char **ptrdata, int *cmd);
int pcr_cmctl(int fd, char *to, int cmd, ...);

#endif  /* ifndef _PCR_H */
